package javax.swing.plaf.multi;

import javax.accessibility.Accessible;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.JComponent;
import java.awt.Rectangle;
import javax.swing.JTabbedPane;
import javax.swing.plaf.ComponentUI;
import java.util.Vector;
import javax.swing.plaf.TabbedPaneUI;

public class MultiTabbedPaneUI extends TabbedPaneUI
{
    protected Vector uis;
    
    public MultiTabbedPaneUI() {
        this.uis = new Vector();
    }
    
    public ComponentUI[] getUIs() {
        return MultiLookAndFeel.uisToArray(this.uis);
    }
    
    @Override
    public int tabForCoordinate(JTabbedPane tabbedPane, int n, int n2) {
        int tabForCoordinate = ((TabbedPaneUI)(TabbedPaneUI)this.uis.elementAt(0)).tabForCoordinate(tabbedPane, n, n2);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TabbedPaneUI)(TabbedPaneUI)this.uis.elementAt(i)).tabForCoordinate(tabbedPane, n, n2);
        }
        return tabForCoordinate;
    }
    
    @Override
    public Rectangle getTabBounds(JTabbedPane tabbedPane, int n) {
        Rectangle tabBounds = ((TabbedPaneUI)(TabbedPaneUI)this.uis.elementAt(0)).getTabBounds(tabbedPane, n);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TabbedPaneUI)(TabbedPaneUI)this.uis.elementAt(i)).getTabBounds(tabbedPane, n);
        }
        return tabBounds;
    }
    
    @Override
    public int getTabRunCount(JTabbedPane tabbedPane) {
        int tabRunCount = ((TabbedPaneUI)(TabbedPaneUI)this.uis.elementAt(0)).getTabRunCount(tabbedPane);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((TabbedPaneUI)(TabbedPaneUI)this.uis.elementAt(i)).getTabRunCount(tabbedPane);
        }
        return tabRunCount;
    }
    
    @Override
    public boolean contains(JComponent component, int n, int n2) {
        int contains = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).contains(component, n, n2);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).contains(component, n, n2);
        }
        return contains;
    }
    
    @Override
    public void update(Graphics g, JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).update(g, c);
        }
    }
    
    public static ComponentUI createUI(JComponent component) {
        MultiTabbedPaneUI multiTabbedPaneUI = new MultiTabbedPaneUI();
        return MultiLookAndFeel.createUIs(multiTabbedPaneUI, ((MultiTabbedPaneUI)multiTabbedPaneUI).uis, component);
    }
    
    @Override
    public void installUI(JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).installUI(c);
        }
    }
    
    @Override
    public void uninstallUI(JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).uninstallUI(c);
        }
    }
    
    @Override
    public void paint(Graphics g, JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).paint(g, c);
        }
    }
    
    @Override
    public Dimension getPreferredSize(JComponent component) {
        Dimension preferredSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getPreferredSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getPreferredSize(component);
        }
        return preferredSize;
    }
    
    @Override
    public Dimension getMinimumSize(JComponent component) {
        Dimension minimumSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getMinimumSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getMinimumSize(component);
        }
        return minimumSize;
    }
    
    @Override
    public Dimension getMaximumSize(JComponent component) {
        Dimension maximumSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getMaximumSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getMaximumSize(component);
        }
        return maximumSize;
    }
    
    @Override
    public int getAccessibleChildrenCount(JComponent component) {
        int accessibleChildrenCount = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getAccessibleChildrenCount(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getAccessibleChildrenCount(component);
        }
        return accessibleChildrenCount;
    }
    
    @Override
    public Accessible getAccessibleChild(JComponent component, int n) {
        Accessible accessibleChild = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getAccessibleChild(component, n);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getAccessibleChild(component, n);
        }
        return accessibleChild;
    }
}
